exec("./datablocks.cs");
function servercmdap(%cl)
{
	if(%cl.asp == 1)
	{
		%cl.asp = 0;
		return;
	}
	if(isObject(%cl.player))
	{
		%cl.asp = 1;
		astralProject(%cl);
	}
	else
	{
		%cl.centerPrint("\c2You must be spawned to do this.");
		%cl.schedule(2000,centerPrint,"");
	}
}
function astralProject(%cl,%p,%player,%count)
{
	if(isObject(%cl.player))
	{
		%count++;
		if(%p != 1)
		{
			%player = %cl.player;
			%copy = new Player()
			{
			position = %player.getPosition();
			rotation = %player.rotation;
			scale = %player.scale;
			dataBlock = %player.dataBlock;
			};
			%copy.setTransform(getWord(%player.getPosition(),0) SPC getWord(%player.getPosition(),1) SPC getWord(%player.getPosition(),2) + 0.2);
			%copy.setVelocity(vectorScale(%player.getVelocity(),3));
			%copy.addVelocity(0 SPC 0 SPC getRandom(10,15));
			%cl.setControlObject(%copy);
			%ppos = %player.getPosition();
			%player = %copy;
			%cl.copy = %copy;
			%player.returnPosition = %ppos;
			%p = 1;
			astralColor(%player,%cl);
			%cl.astrallight = new fxLight()
			{
				dataBlock = Astral_Player;
			};
			%cl.astrallight.attachtoobject(%player);
		}
		if(!isObject(%player) || %cl.asp == 0)
		{
			%cl.asp = 0;
			%cl.astrallight.delete();
			%cl.copy.delete();
			if(isObject(%cl.player))
			{
				%cl.setControlObject(%cl.player);	
			}
			return;
		}
		if(%count >= getRandom(5,10))
		{
			%choice = getRandom(1);
			if(%choice == 0)
			{
				%LD = "Astral_Orb";
			}
			if(%choice == 1)
			{
				%LD = "Astral_Energy";
			}
			%light = new fxLight()
			{
				dataBlock = %LD;
			};
			%light.setTransform(getWord(%player.getPosition(),0) + getRandom(-20,20) SPC getWord(%player.getPosition(),1) + getRandom(-20,20) SPC getWord(%player.getPosition(),2) + getRandom(-20,20));
			%light.schedule(getRandom(500,2000),delete);
			%count = 0;
		}
		if(isObject(%player)){
		%player.addVelocity(getRandom(-3,3) * ("0." @ getRandom(1)) SPC getRandom(-3,3) * ("0." @ getRandom(1)) SPC getRandom(1) * ("0." @ getRandom(50)));
		}
		schedule(500,0,astralProject,%cl,%p,%player,%count);
	} else
	{
		%cl.asp = 0;
		if(isObject(%player))
		{
			%player.delete();
		}
	}
}
function astralColor(%player,%cl)
{
	if(isObject(%player) && %cl.asp == 1)
	{
		%cr = getRandom(1);
		%cg = getRandom(1);
		%cb = getRandom(1);
		%ca = getRandom(1);
		if(%cr == 0)
		{
			if(%player.r > 0)
			{
				%player.r = %player.r - 0.1;
			}
		}
		if(%cg == 0)
		{
			if(%player.g > 0)
			{
				%player.g = %player.g - 0.1;
			}
		}
		if(%cb == 0)
		{
			if(%player.b > 0)
			{
				%player.b = %player.b - 0.1;
			}
		}
		if(%cr == 1)
		{
			if(%player.r < 255)
			{
				%player.r = %player.r + 0.1;
			}
		}
		if(%cg == 1)
		{
			if(%player.g < 255)
			{
				%player.g = %player.g + 0.1;
			}
		}
		if(%cb == 1)
		{
			if(%player.b < 255)
			{
				%player.b = %player.b + 0.1;
			}
		}
		if(%ca == 1)
		{
			if(%player.a < 0.4)
			{
				%player.a = %player.a + 0.1;
			}
		}
		if(%cb == 0)
		{
			if(%player.a > 0.3)
			{
				%player.a = %player.a - 0.1;
			}
		}
		if(getWord(%player.getPosition(),2) > 2 || getWord(%player.getPosition(),2) < -2)
		{
			%player.addVelocity(0 SPC 0 SPC 1.5);
		}
		%vr = 1 - %player.r;
		%vg = 1 - %player.g;
		%vb = 1 - %player.b;
		commandToClient(%cl, 'setVignette', 0,%vr SPC %vg SPC %vb SPC 1, %vg SPC %vr SPC %vg SPC getRandom(1) - %player.a);
		%player.setNodeColor("ALL",%player.r SPC %player.g SPC %player.b SPC %player.a);
		schedule(100,0,astralColor,%player,%cl);
	} else
	{
		commandToClient(%cl, 'setVignette', 0, 0, 0);
		cancel(%cl.astralMusic);
	}
}
package astralMovement
{
function armor::onTrigger(%this,%obj,%slot,%val)
{
	parent::onTrigger(%this,%obj,%slot,%val);
	if(%obj.getControllingClient().asp == 1)
	{
	if(%val == 0)
	{
		cancel(%obj.getControllingClient().mov);
	}
	%obj.val = %val;
	astralMovement(%slot,%obj);
	}
}
}; activatePackage(astralMovement);
function astralMovement(%slot,%obj,%count)
{
	if(%obj.getControllingClient().lastslot == 0)
	{
		%obj.getControllingClient().copy.setVelocity("0 0 0");
		%obj.getControllingClient().lastslot = "1337";
	}
	if(%slot == 0 && %obj.val == 1)
	{
		%obj.setTransform(vectorAdd(%obj.getEyeVector(),%obj.getPosition()));
		%obj.getControllingClient().lastslot = 0;
		%obj.getControllingClient().mov = schedule(10,0,astralMovement,%slot,%obj);
	}
	else if(%slot == 2 && %obj.val == 1)
	{
		%obj.addVelocity("0 0 3");
		%obj.getControllingClient().mov = schedule(100,0,astralMovement,%slot,%obj);
	}
	else if(%slot == 3 && %obj.val == 1)
	{
		%obj.addVelocity("0 0 -3");
		%obj.getControllingClient().mov = schedule(100,0,astralMovement,%slot,%obj);
	}
	else if(%slot == 4 && %obj.val == 1)
	{
		if(%count<95)
		{
			%count++;	
		}
		%obj.setVelocity(vectorScale(%obj.getEyeVector(),%count SPC %count SPC %count));
		%obj.getControllingClient().mov = schedule(100,0,astralMovement,%slot,%obj,%count);
	}
}